package mobile;

/*
 * This class is used to create the media file for all client mobile hosts
 * 
 */
import java.io.File;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import sim.MergeAudioVideo.src.Merge;
import sim.MergeFrame.src.MovieMaker;
import sim.bean.ConfigurationPacket;
import wifi.RequestQueue;

public class CreateMediaFile implements Runnable{
	private Thread thread;
	private List list;
	public CreateMediaFile() {
		thread = new Thread(this);
		thread.start();
		
	}
	//call creteMedia method in each second
	public void run() {
		while(true){
			// TODO Auto-generated method stub
			
			try {
				createMedia();
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	//if The queue have any object to merge then merging method called to merge the audio and video
	private void createMedia(){
		Set set;
		Iterator iterator;
		String temp;
		String status;
		HashMap tempHashMap =RequestQueue.create_media; 
		if(tempHashMap.size()>0){
			//get the key
			set=tempHashMap.keySet();
			iterator = set.iterator();
			if(iterator.hasNext()){
				//assign the key into temp variable
				temp=iterator.next().toString();
				// get status of the merging
				status = merging(temp,(ConfigurationPacket) tempHashMap.get(temp));
				System.out.println("media for "+ temp + status);
				/*
				 * if merging process is run successfully 
				 * then the particular object is deleted 
				 * from the attribute crete_media hashmap of RequestQueue class
				 */ 
				if(status.equals("Done")){
					RequestQueue.create_media.remove(temp);
				}
			}
		}
	}
	private String merging(String host_name,ConfigurationPacket configPacket){
		String return_statment;
		list=Arrays.asList(new File(host_name + File.separator + "split-frames").list());
		Collections.sort(list, new AlphanumComparator());
		File files[] = new File[list.size()];
		for(int i=0;i<list.size();i++){
			files[i] = new File(host_name + File.separator + "split-frames"+ File.separator+list.get(i).toString());
			System.out.println(files[i].getName());
		}
		try {
			/*
			 * create the video folder to store the merged video file 
			 * for corresponding mobile host folder
			 */
			new File(host_name + File.separator+"video").mkdir();
			/*
			 * create the received_files folder to store the merged final media file 
			 * for corresponding mobile host folder
			 */
			new File(host_name + File.separator+"received_files").mkdir();
			// object of output file
			File video_file = new File(host_name + File.separator+"video"+File.separator +"out.avi");
			//create the video file and store the video folder
			new MovieMaker(configPacket.getWidth(),configPacket.getHeight(),configPacket.getFrame_size(),video_file,files).makeMovie();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		String str[]={
				"file:" + System.getProperty("user.dir")+ File.separator+host_name + File.separator+"video"+File.separator +"out.avi",
				"file:" + System.getProperty("user.dir")+ File.separator+host_name + File.separator+"audio"+File.separator +"split-aud1.wav",
				"-o",
				"file:" + System.getProperty("user.dir")+ File.separator+host_name + File.separator+"received_files"+ File.separator+configPacket.getFile_name()};
		//create the media file and get status of the creation
		return_statment = new Merge().merging(str);
		
		return return_statment;
	}
	public static void main(String args[]){
//		new CreateMediaFile("Mob1");
	}
}
