package mobile;

/*
 * Create MobileProcess object for all mobile host objects
 * This class is receive the object which is transferred by the UMTS or WiFI
 * to corresponding mobile host port
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;

import sim.ImgDevice;
import sim.SimulationLog;
import sim.bean.BufferedData;
import wifi.RequestQueue;

public class MobileProcess implements Runnable {
	private String receivePort = "";
	private BufferedData bufferedData = null;
	private Thread thread;
	
	private final int ALLOWED_QUEUE_SIZE = 200;
	private ServerSocket serverSocket = null;
	private Socket clientSocket = null;
	private ObjectInputStream in = null;
	private FileOutputStream fileOutputStream = null;
	private ObjectOutputStream out;	
	private int port;
	private String name;
	// mobile name and mobile port vary for all the mobile hosts and WiFi
	public MobileProcess(int port,String name)
	{
		this.port = port;
		this.name = name;
		try {
			serverSocket = new ServerSocket(port);
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//		System.out.println("Listening");
		
		thread=new Thread(this);
		thread.start();
	}
	/*
	 *  (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 * Socket connection is created to receive the object in this method
	 */
	public void run()
	{
		System.out.println("The '" + name + "' mobile host receiver is running");
		try {
			while(true)
			{
				clientSocket = serverSocket.accept();// create the connection with source
				in=new ObjectInputStream(clientSocket.getInputStream());//input object to receive the object
				bufferedData = (BufferedData)in.readObject(); //get the object from the source
				if(bufferedData.getLayer_type().equals("DataLayer")){
					SimulationLog.write(name);
					SimulationLog.write(bufferedData.getFileName()+" is received from " + bufferedData.getNetwork());
					System.out.println("fileName" + bufferedData.getFileName());
					// if the received object as frame then the object is converted as Jpeg file
					if(bufferedData.getFiletype().equals("Frame")){
						System.out.println(bufferedData.getDestinationHost()+File.separator + "split-frames" + " is creted ");
						System.out.println(new File(bufferedData.getDestinationHost()).mkdir());
						System.out.println(new File(bufferedData.getDestinationHost()+File.separator + "split-frames").mkdir());
						fileOutputStream =new FileOutputStream(bufferedData.getDestinationHost()+File.separator + "split-frames"+File.separator+bufferedData.getFileName());
						fileOutputStream.write(bufferedData.getBuffer());
						fileOutputStream.close();
					}
					//if the received object as audio then the object conveted as audio file 
					else{
						new File(bufferedData.getDestinationHost()+File.separator + "audio").mkdir();
						fileOutputStream =new FileOutputStream(bufferedData.getDestinationHost()+File.separator + "audio"+File.separator+bufferedData.getFileName());
						fileOutputStream.write(bufferedData.getBuffer());
						fileOutputStream.close();
					}
				}
				//if received fonfiguration packat the object is added into queue
				else{
					RequestQueue.addRequestCreateMedia(name,bufferedData.getConfigurationPacket());
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args)
	{
//		new MobileProcess();
	}
}
