package sim;

//This class is used crete image component in simulation
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.Serializable;
import java.util.Vector;

import mobile.MobileProcess;

import wifi.WiFiReceiver;

import com.gif4j.TextPainter;
import com.gif4j.Watermark;

public class ImgDevice extends Canvas{
	private Image image;
	private int port;
	private Vector childHosts;
	private ImgDevice parentDevice;
	private String name="";
	private String type="equipment";
	private Point location = new Point(0,0);
	private ImgDeviceBean imgDeviceBean;
	public ImgDevice (Image image,String name, String type, Point location,int port) {
		imgDeviceBean = new ImgDeviceBean();
		imgDeviceBean.setName(name);
		imgDeviceBean.setPort(port);
		this.port = port;
		childHosts = new Vector();
		this.image = image;
		this.location = location;
		this.name = name;
		this.type = type;
		if(type.equals("WiFi")){
			new WiFiReceiver(port,name);
		}
		else if(type.equals("mobile")){
			new MobileProcess(port,name);
		}
	}
	public void paint(Graphics g) {
//		g.setColor(Color.CYAN);
		g.drawLine(10,10,100,100);
		g.drawImage(BufferedImageToImage(addTextWatermarkToImage(convert(image),name)),0,0,size().width,size().height,this);
		
/*		if(type.equals("mobile")){
		System.out.println(this.getX()+","+this.getY()+","+parentDevice.getX() + "," + parentDevice.getY());
		g.drawLine(this.getX(),this.getY(),parentDevice.getX(),parentDevice.getY());
		}
*/	
		
	}
	private Image BufferedImageToImage(BufferedImage i){
		return Toolkit.getDefaultToolkit().createImage(i.getSource());
	}
	public BufferedImage convert(Image im)
	 {
	    BufferedImage bi = new BufferedImage(size().width,size().height,BufferedImage.TYPE_INT_RGB);
	    Graphics bg = bi.getGraphics();
	    bg.drawImage(im, 0, 0, null);
	    bg.dispose();
	    return bi;
	 }
	//merge text with image
	public BufferedImage addTextWatermarkToImage(BufferedImage image, String watermarkText) {
		//create new TextPainter
		TextPainter textPainter = new TextPainter(new Font("Verdana", Font.BOLD, 10));
		textPainter.setOutlinePaint(Color.WHITE);
		textPainter.setBackgroundColor(Color.CYAN);
		//render the specified text outlined
		BufferedImage renderedWatermarkText = textPainter.renderString(watermarkText,true);
		//create new Watermark
		Watermark watermark = new Watermark(renderedWatermarkText, Watermark.LAYOUT_BOTTOM_CENTER);
		//apply watermark to the specified image and return the result
		return watermark.apply(image);
	}
	public void update(Graphics g) {
		paint(g);
	}
	public Image getImage() {
		return image;
	}
	public void setImage(Image image) {
		this.image = image;
	}
	public Point getLocation() {
		return location;
	}
	public void setLocation(Point location) {
		this.location = location;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public ImgDevice getParentName() {
		return parentDevice;
	}
	public void setParentName(ImgDevice parentName) {
		this.parentDevice = parentName;
	}
	public Vector getChildHosts() {
		return childHosts;
	}
	public void setChildHosts(Vector childHosts) {
		this.childHosts = childHosts;
	}
	public int getPort() {
		return port;
	}
	public void setPort(int port) {
		this.port = port;
	}
	public String toString(){
		return name;
		
	}
	public ImgDeviceBean getImgDeviceBean() {
		return imgDeviceBean;
	}
	public void setImgDeviceBean(ImgDeviceBean imgDeviceBean) {
		this.imgDeviceBean = imgDeviceBean;
	}
}
