package sim;
//The class is used to show the mobile hosts on the frame invironment
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.util.Hashtable;
import java.util.Random;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import javax.swing.SwingUtilities;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import mobile.CreateMediaFile;

import wifi.RequestQueue;

public class Simulation {
	
	private JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="0,2"
	private JPanel jContentPane = null;
	private JToolBar jJToolBarBar = null;
	private JPanel jPanel = null;
	private JButton jButtonWiFi = null;
	private JButton jButtonUMTS = null;
	private JButton jButtonMobile = null;
	private int mob_host_increment = 0;
	private int umts_increment = 0;
	private int wifi_increment = 0;
	protected int posY;
	protected int x1;
	protected int y1;
	public static Vector mobileVector;
	public static Vector WifiVector;
	public static Hashtable parentHashtable;
	private ImgDevice UMTSDevice;
	private int port;
	public static Image devMob, devWiFi, devUMTS;
	
	
	/**
	 * This method initializes jFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setSize(new java.awt.Dimension(753,400));
			jFrame.setExtendedState(jFrame.MAXIMIZED_BOTH);
			jFrame.setTitle("Simulation");
			jFrame.setForeground(java.awt.Color.cyan);
			jFrame.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
			jFrame.setContentPane(getJContentPane());
			jFrame.setJMenuBar(getJJMenuBar());
			jFrame.setVisible(true);
		}
		return jFrame;
	}
	
	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBackground(java.awt.SystemColor.window);
			jContentPane.add(getJPanel(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jJToolBarBar	
	 * 	
	 * @return javax.swing.JToolBar	
	 */
	private JToolBar getJJToolBarBar() {
		if (jJToolBarBar == null) {
			jJToolBarBar = new JToolBar();
			
			jJToolBarBar.setPreferredSize(new java.awt.Dimension(18,40));
			jJToolBarBar.setBounds(new java.awt.Rectangle(3,5,147,37));
			jJToolBarBar.add(getJButtonWiFi());
			jJToolBarBar.add(getJButtonUMTS());
			jJToolBarBar.add(getJButtonMobile());
		}
		return jJToolBarBar;
	}
	
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.setBounds(new java.awt.Rectangle(2,1,159,46));
			jPanel.add(getJJToolBarBar(), null);
		}
		return jPanel;
	}
	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenuFile());
		}
		return jJMenuBar;
	}
	
	/**
	 * This method initializes jMenuFile	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenuFile() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
			jMenuFile.setText("File");
			jMenuFile.add(getJMenuItemSendFile());
		}
		return jMenuFile;
	}
	/**
	 * This method initializes jMenuItemSendFile	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItemSendFile() {
		if (jMenuItemSendFile == null) {
			jMenuItemSendFile = new JMenuItem();
			jMenuItemSendFile.setText("SendFile");
			jMenuItemSendFile.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
//					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					new SenderHome();
				}
			});
		}
		return jMenuItemSendFile;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new Simulation();
	}
	
	/**
	 * This method initializes jButtonWiFi	
	 * 	
	 * @return javax.swing.JButton	
	 */
	//create the imgdevice object for WiFi	
private JButton getJButtonWiFi() {
		if (jButtonWiFi == null) {
			jButtonWiFi = new JButton();
			jButtonWiFi.setIcon(new ImageIcon(getClass().getResource("/wifi3.jpg")));
			jButtonWiFi.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					wifi_increment++;
					if(wifi_increment<=3){
						ImgDevice imgDevice = new ImgDevice(devWiFi,"WF"+wifi_increment,"WiFi",new Point(10,50),port);
						imgDevice.resize(30,40);
						imgDevice.move(10,50);
						imgDevice.setPort(port);
						port++;
						System.out.println("Port of " + imgDevice +" is :" +imgDevice.getPort());
						imgDevice.addMouseMotionListener(mouseMotionAdapter);
						imgDevice.addMouseListener(mouseAdapter);
						parentHashtable.put("WF"+wifi_increment,imgDevice);
						jFrame.add("Center",imgDevice);
						WifiVector.add(imgDevice);
						Vector vector = new Vector();
						RequestQueue.createRequestQueue("WF"+wifi_increment,vector);
						setParentToMobile();
					}
					else{
						new JOptionPane().showMessageDialog(null,"Only 3 WiFi is allowed into the simulation");
					}
				}
			});
		}
		return jButtonWiFi;
	}
	/**
	 * This method initializes jButtonUMTS	
	 * 	
	 * @return javax.swing.JButton	
	 */
//create the imgdevice object for UMTS
	private JButton getJButtonUMTS() {
		if (jButtonUMTS == null) {
			jButtonUMTS = new JButton();
			jButtonUMTS.setIcon(new ImageIcon(getClass().getResource("/umts2.jpg")));
			jButtonUMTS.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					umts_increment++;
					if(umts_increment<=1){
						UMTSDevice = new ImgDevice(devUMTS,"UM"+umts_increment,"UMTS",new Point(450,350),port);
						UMTSDevice.resize(30,40);
						UMTSDevice.move(450,350);
						UMTSDevice.addMouseMotionListener(mouseMotionAdapter);
						UMTSDevice.addMouseListener(mouseAdapter);
						jFrame.add("Center",UMTSDevice);
					}
					else{
						new JOptionPane().showMessageDialog(null,"Only one UMTS is allowed into the simulation");
					}
				}
			});
		}
		return jButtonUMTS;
	}
	
	/**
	 * This method initializes jButtonMobile	
	 * 	
	 * @return javax.swing.JButton	
	 */
//create the imgdevice object fro mobile
	private JButton getJButtonMobile() {
		if (jButtonMobile == null) {
			jButtonMobile = new JButton();
			jButtonMobile.setIcon(new ImageIcon(getClass().getResource("/mob5.jpg")));
			jButtonMobile.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("Mobile button is clicked");
					mob_host_increment++;
					if(mob_host_increment<=10){
						ImgDevice imgDevice = new ImgDevice(devMob,"Mob"+mob_host_increment,"mobile",new Point(550,530),port);
						imgDevice.setPort(port);
						port++;
						System.out.println("Port of " + imgDevice +" is :" +imgDevice.getPort());
						imgDevice.resize(30,40);
						imgDevice.move(550,530);
						imgDevice.addMouseMotionListener(mouseMotionAdapter);
						imgDevice.addMouseListener(mouseAdapter);
						jFrame.add("Center",imgDevice);
						parentHashtable.put("Mob"+mob_host_increment,imgDevice);
						mobileVector.add(imgDevice);
						setParentToMobile();
					}
					else{
						new JOptionPane().showMessageDialog(null,"Only 10 mobiles are allowed into the simulation");
					}
				}
			});
		}
		return jButtonMobile;
	}
	private MouseMotionAdapter mouseMotionAdapter =new MouseMotionAdapter() {
		ImgDevice imgtemp;
		public void mouseDragged(MouseEvent e) {
			imgtemp = (ImgDevice)e.getSource();
			x1 = x1+ e.getX(); y1 = y1+ e.getY();
//			System.out.println(x1 + " " + y1);
			imgtemp.setLocation(x1,y1);
			imgtemp.move(x1,y1);
			imgtemp.repaint();
		}
	};
	private MouseAdapter mouseAdapter = new MouseAdapter() {
		ImgDevice imgtemp;
		private int posX;
		public void mouseReleased(MouseEvent arg0) {
			// TODO Auto-generated method stub
//			super.mouseReleased(arg0);
//			imgtemp.move(x1,y1);
			setParentToMobile();
		}
		public void mousePressed(MouseEvent e) {
			imgtemp = (ImgDevice)e.getSource();
			posX = imgtemp.getX(); posY = imgtemp.getY();
			imgtemp.move(posX,posY);
//			System.out.println("entered :" + imgtemp.getX() + " , " + imgtemp.getY()+","+imgtemp.getName());
			if(e.getClickCount() == 1) {
				if(SwingUtilities.isRightMouseButton(e)==true) {
					System.out.println("you right clicked on the " + imgtemp.getName());
					ExecMenu mnu = new ExecMenu(imgtemp);
					mnu.show(jFrame, posX+30, posY+30);
				}
			}
		}
		public void mouseEntered(MouseEvent e) {
//			System.out.println("mouse entered");
			imgtemp = (ImgDevice)e.getSource();
			x1 = imgtemp.getX(); y1 = imgtemp.getY();
			imgtemp.setLocation(x1,y1);
//			System.out.println("entered :" + imgtemp.getX() + " , " + imgtemp.getY()+","+imgtemp.getName());
		}
		public void mouseClicked(MouseEvent e) {
//			System.out.println("mouse clicked");
			
			imgtemp = (ImgDevice)e.getSource();
			posX = imgtemp.getX(); posY = imgtemp.getY();
			x1 = posX; y1 = posY;
			imgtemp.setLocation(x1,y1);
			
//			System.out.println("clicked :" + imgtemp.getX() + " , " + imgtemp.getY()+","+imgtemp.getName());
		}
	};
	private JMenuBar jJMenuBar = null;
	private JMenu jMenuFile = null;
	private JMenuItem jMenuItemSendFile = null;
	
	/**
	 * This is the default constructor
	 */
	public Simulation() {
		super();
		getJFrame();
		SimulationLog.write("The Simulation is Started");
		port = 5000;
		mobileVector = new Vector();
		WifiVector = new Vector();
		parentHashtable = new Hashtable(); 
		devMob = Toolkit.getDefaultToolkit().getImage("./mob5.jpg");
		devWiFi = Toolkit.getDefaultToolkit().getImage("./wifi3.jpg");
		devUMTS = Toolkit.getDefaultToolkit().getImage("./umts2.jpg");
		new CreateMediaFile();
	}
	
	/*
	 * 	public void run() {
	 // TODO Auto-generated method stub
	  System.out.println("started");
	  while(true){
	  try {
	  Thread.sleep(5000);
	  reArrange();
	  } catch (InterruptedException e) {
	  // TODO Auto-generated catch block
	   e.printStackTrace();
	   }
	   }
	   }
	   */
	
	private void setParentToMobile(){
		/*		System.out.println("mobile nodes" + mobileVector);
		 System.out.println("wifi nodes" + WifiVector);
		 */		
		ImgDevice tempMobileDevice;
		ImgDevice tempWiFiDevice;
		Point p1 = new Point();
		Point p2 = new Point(); 
		Vector tempVector = new Vector();
		double tempDistance = 0;
		for(int j=0;j<WifiVector.size();j++){
			tempWiFiDevice = (ImgDevice) WifiVector.get(j);
			p2 = new Point(tempWiFiDevice.getX(),tempWiFiDevice.getY());
				tempWiFiDevice.setChildHosts(new Vector());
			for(int i=0;i<mobileVector.size();i++){
				tempMobileDevice = (ImgDevice) mobileVector.get(i);
				p1 = new Point(tempMobileDevice.getX(),tempMobileDevice.getY());
				if(p1.distance(p2)<=250){
					tempVector = tempWiFiDevice.getChildHosts();
					tempVector.add(tempMobileDevice);
					tempWiFiDevice.setChildHosts(tempVector);
				}
				
				/*				if(entryFlag){
				 entryFlag = false;
				 tempDistance = p1.distance(p2);
				 tempMobileDevice.setParentName(tempWiFiDevice);
				 mobileVector.remove(i);
				 mobileVector.add(i,tempMobileDevice);
				 parentHashtable.put(tempMobileDevice.getName(),tempWiFiDevice);
				 }
				 else if(tempDistance>p1.distance(p2)){
				 tempDistance = p1.distance(p2);
				 tempMobileDevice.setParentName(tempWiFiDevice);
				 mobileVector.remove(i);
				 mobileVector.add(i,tempMobileDevice);
				 parentHashtable.put(tempMobileDevice.getName(),tempWiFiDevice);
				 }
				 *///				System.out.println(p1+" , " +p2);
			}
		}
		for(int i=0;i<WifiVector.size();i++){
			System.out.println(((ImgDevice)WifiVector.get(i)).getChildHosts());
		}
//		System.out.println(parentHashtable);
	}

	private void reArrange(){
		System.out.println(mobileVector);
		ImgDevice imgDevice;
		int tempX,tempY,flag;
		for(int i = 0;i<mobileVector.size();i++){
			imgDevice = (ImgDevice) mobileVector.get(i);
			System.out.println();
			Point point = imgDevice.getLocation();
			Random r = new Random();
			tempX = (int) (r.nextFloat()*10) ;
			tempY = (int) (r.nextFloat()*10) ;
			flag = (int) (r.nextFloat()*10) ;
			System.out.println(flag);
			if (point.x + tempX >500 && point.y+ tempY > 500){
				switch (flag) {
				case 1:
					point.x = point.x + tempX ;
					point.y = point.y + tempY ;
					break;
				case 2:
					point.x = point.x + tempX ;
					point.y = point.y - tempY ;
					break;
					
				case 3:
					point.x = point.x - tempX ;
					point.y = point.y + tempY ;
					break;
				case 4:
					point.x = point.x - tempX ;
					point.y = point.y - tempY ;
					break;
				}
			}
			System.out.println("rearranged");
			imgDevice.setLocation(point);
			imgDevice.move(point.x,point.y);
		}
	}
//provide the all the mobile names
	public static String[] getMobileHostName(){
		String temp[]=new String[100];
		for(int i=0;i<mobileVector.size();i++){
			temp[i]=mobileVector.get(i).toString();
		}
		return temp;
	}
}