/*
 * @(#)SplitAsFrames.java	23/04/2008
 *
 * MaaYoke Technology
 * This is for new program trainee
 */

package sim.splitframes.src;

/**
 * This class is used to split the frames from the video file
 * 
 * @author	durai
 * @version 	23/04/2008
 * @since       
 */

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.io.File;
import java.io.FileOutputStream;

import javax.media.CannotRealizeException;
import javax.media.Manager;
import javax.media.MediaLocator;
import javax.media.NoPlayerException;
import javax.media.Player;
import javax.media.control.FormatControl;
import javax.media.control.FrameGrabbingControl;
import javax.media.control.FramePositioningControl;
import javax.media.format.VideoFormat;
import javax.media.util.BufferToImage;
import javax.swing.ImageIcon;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGEncodeParam;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

public class SplitAsFrames extends javax.swing.JFrame {
	/** Creates new form selector */
	
	public SplitAsFrames(String url) {
//		to create a player
		try
		{
			/*
			 * give the exact file name from the current directory
			 */
			String file = "file:" + System.getProperty("user.dir") + File.separator + url;
			// create the player object using Manager class pass MediaLocator object
			player = Manager.createRealizedPlayer(new MediaLocator(file));
		}
		catch (java.io.IOException e)
		{
			System.out.println("an error occurred while creating the player");
		}
		catch (NoPlayerException e)
		{
			System.out.println("No player has been created");
		}
		catch(CannotRealizeException e)
		{
			System.out.println(e.getMessage());
		}
//		initial frame is 0, to position it
		numFrame = 0;
		
//		if the player exists
		if ( player != null )
		{
//			obtain frame positioning capabilities
			framePositioningControl = (FramePositioningControl)player.getControl("javax.media.control.FramePositioningControl");
			
//			obtain frame grabbing capabilities
			extractor = (FrameGrabbingControl)player.getControl("javax.media.control.FrameGrabbingControl");
		}
	}
	public void convertImageArray()
	{
		Image img2 = null;
		int imagecheck=0;
		int i=0;
		try{
			//move the player frame by frame to pick out each frame
			while(player!= null)
			{
				i++;
				//goto the first frame
				framePositioningControl.seek(i);
				//check the player object whether the object have video file or not
				if (player != null)
				{
					// get the full format control of the given video
					formatControl = (FormatControl)player.getControl("javax.media.control.FormatControl");
					// check the extractor object 
					if (extractor != null)
						System.out.println("extractor is not created ");
					if (formatControl != null)
					{
						// take the frame and store it in a BufferToImage object
						BufferToImage conversor = new BufferToImage((VideoFormat)extractor.grabFrame().getFormat());
						if (extractor.grabFrame()==null)
							System.out.println("extract images");
						
						if (conversor.createImage(extractor.grabFrame()) == null)
							System.out.println("The image is not created");
						
//						The image is created from the BufferedImage 
						// grabFrame() provide the pixel array to create the image object
						imag = conversor.createImage(extractor.grabFrame());
						
						// The flow is forwarded into "if block" if the video file have minimum 2 frames
						if(i>2){
							/*
							 *  some times extractor extract 
							 *  infinity frames after extracted 
							 *  the actual last frame of video file
							 *  (repeated the last frame more time)
							 */
							// check the last two frames is equal or not 
							if(imageVerify(imag,img2)){
								imagecheck=0;
								System.out.println("imagecheck : " +imagecheck);
							}
							else{
								// the imagecheck value is incremented if the created frames are equal continuously
								imagecheck++;
							}
							// the extracted procees is stopped if the created frames are equal continuously
							if(imagecheck>5)break;
							// created image is stored in the following path 
							String path="split-frames\\start"+i+".jpeg";
							//create the ImageIcon for image to get width and height
							ImageIcon tempimageicon=new ImageIcon(imag);
							//getwidth
							int width = tempimageicon.getIconWidth();//500;
							//getheight
							int height =tempimageicon.getIconHeight();// 500;
							
							/*
							 * the following set of standard code  is to create the jpeg file for the image
							 */
							//create BufferedImage object with parameter of height and width
							BufferedImage bi = new BufferedImage(width,height,1);
							try{
								FileOutputStream f = new FileOutputStream(path);
								//create the graphics object
								Graphics g = bi.createGraphics();
								g.drawImage(imag,0,0,null);
								g.dispose();
								//using encoder only we write the image object to file
								JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(f);
								JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(bi);
								//set the quality for the jpeg image
								param.setQuality((float)((double)75 / 100D), true);
								// create the jpeg file
								encoder.encode(bi, param);
								f.close();
							}catch(Exception e)
							{
								System.out.println("Jpeg Writer"+ e);
							}
						}
						img2=imag;
						System.out.println("This is image1 format " + extractor.grabFrame().getFormat().toString());
					}
				}
/*				if(i==5)
				break;*/
			}
		}
		catch(Exception e){	}
	}
//	compare the images
	/*
	 * 
	 */
	private boolean imageVerify(Image newimg1,Image newimg2){
		BufferedImage ima1, ima2;
		
		ima1 = (BufferedImage)newimg1;
		ima2 = (BufferedImage)newimg2;
		
		// Get the information about the given images
		Raster raster1, raster2;
		
		raster1 = ima1.getData();
		raster2 = ima2.getData();
		
		int numPixelDiff;
		int width, height;
		int numBands, numPixeles;
		int i,j,k;
		int minX, minY;
		
		numPixeles =0;
		
		i=0;
		j=0;
		k=0;
		numPixelDiff = 0;
		
		numBands = raster1.getNumBands();
		minX = raster1.getMinX();
		minY = raster1.getMinY();
		height = raster1.getHeight();
		width = raster1.getWidth();
		
		System.out.println("NumBandas: " + numBands + " mix: " + minX + " minY: " + minY + " width: " + width + " height: " + height);
		numBands = 1;
		try
		{ 
			
			System.out.println("Loss pixels");
			
			for (i=1; i<= numBands; i++) 
			{
				for (j =minY; j< height; j++) 
				{
					for(k=minX; k<width; k++) 
					{
						int pixRaster1, pixRaster2;
						
						pixRaster1 = raster1.getSample(k,j,i);
						pixRaster2 = raster2.getSample(k,j,i);
						numPixeles++;
//						System.out.println("PixelR1: " + pixRaster1 + " pixelR2: " + pixRaster2);
						if (pixRaster1 != pixRaster2) 
						{
							numPixelDiff++;
						}
					}
				}
			}
			
			System.out.println(" Pixel Differences :"+numPixelDiff);
			if(numPixelDiff>0){
				return true;
			}
			else{
				return false;
			}
			
		} 
		catch (ArrayIndexOutOfBoundsException e) 
		{
			System.out.println( e.toString());
			System.out.println("i:" + i + " j:" + j + " k:" + k);
		}
		return false;
	}
	
	public static void main(String args[]){
		new SplitAsFrames("split-vid0.mov").convertImageArray();
	}
	
//	variables declaradas por el programador
	public Player reproductor;
	public Player player;
	public FramePositioningControl framePositioningControl;
	public int numFrame;
	public FrameGrabbingControl extractor;
	public Image imagen1;
	public Image imagen2;
	
	public FormatControl formatControl;
//	las imagenes en pantalla
	public javax.swing.JLabel labelImagen1,labelImagen2;
	
//	public Image img_arr[]=new Image[110];
	private Image imag;
}
