package umts;

/*
 * This class multicasts all the splitted frames and audio to direct_mobiles
 * and WiFi 
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.ImageIcon;

import sim.SimulationLog;
import sim.bean.BufferedData;
import sim.bean.ConfigurationPacket;

public class UMTSProcess{
	private BufferedData bufferedData;
	private FileInputStream fileInputStream;
	private byte buffer[];
	private ToSendFile toSendFile;
	
	public UMTSProcess() {
		toSendFile = new ToSendFile();
	}
	// transfer all the frames and audio to selected names
	public void startProcess(String selectedHostNames[],String file_name){
		File audio_file;
		ImageIcon imgico;
		ConfigurationPacket configurationPacket;
		int imgwidth = 0;
		int imgheight = 0;
		int framesize = 15;
		// to get all the splitted frames
		File file[] = new File("split-frames").listFiles();
		// to get the width and height for the frames
		if(file.length>0){
			if(file[0].getName().equals("Thumbs.db"))
				imgico=new ImageIcon("split-frames/"+file[1].getName());//"split-frames/start3.jpeg");
			else
			imgico=new ImageIcon("split-frames/"+file[0].getName());//"split-frames/start3.jpeg");
			imgwidth=imgico.getIconWidth();
			imgheight=imgico.getIconHeight();
		}
		// the following object for configuration to create the media file in client side
		configurationPacket = new ConfigurationPacket(imgwidth,imgheight,framesize,file_name);
		SimulationLog.write("Data Layer is started");
		SimulationLog.write("All the Splitted Frames is transfered");
		//transfer each frames to each hosts and WiFi
		for(int i=0;i<file.length;i++){
			bufferedData = new BufferedData();
			try {
				fileInputStream = new FileInputStream(file[i]);
				buffer = new byte[fileInputStream.available()];
				fileInputStream.read(buffer);
				bufferedData.setBuffer(buffer);
				bufferedData.setFileName(file[i].getName());
				bufferedData.setLayer_type("DataLayer");
				bufferedData.setFiletype("Frame");
				fileInputStream.close();
				file[i].deleteOnExit();
				file[i].delete();
				System.out.println("The " + file[i] + " file is multicast from UMTS");
				SimulationLog.write("The " + file[i] + " file is multicast from UMTS");
				toSendFile.sendFile(bufferedData,selectedHostNames);
				Thread.sleep(1000);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// transfer the audio file
		SimulationLog.write("Audio File is transfered.");
		try {
			audio_file = new File("split-files"+File.separator+"split-aud1.wav");
			fileInputStream = new FileInputStream(audio_file);
			buffer = new byte[fileInputStream.available()];
			fileInputStream.read(buffer);
			bufferedData.setBuffer(buffer);
			bufferedData.setFileName(audio_file.getName());
			bufferedData.setLayer_type("DataLayer");
			bufferedData.setFiletype("audio");
			fileInputStream.close();
			audio_file.deleteOnExit();
			audio_file.delete();
			System.out.println("The " + audio_file + " file is multicast from UMTS");
			SimulationLog.write("The " + audio_file + " file is multicast from UMTS");
			toSendFile.sendFile(bufferedData,selectedHostNames);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// transfer the configuration object to all hosts and WiFi to create the Media
		SimulationLog.write("Configuration Layer is started.");
			bufferedData.setFileName(file_name);
			bufferedData.setLayer_type("ConfigurationLayer");
			bufferedData.setConfigurationPacket(configurationPacket);
			System.out.println("The MainLayer is multicast from UMTS");
			SimulationLog.write("The MainLayer is multicast from UMTS");
			toSendFile.sendFile(bufferedData,selectedHostNames);
	}
}
