package wifi;

/*
 * This class is used to retrieve the BufferedTransfer object 
 * from Vector after retrieve the bufferedTransfer object delete from that
 *  This object is transferred to objectofile to convert as splitted files 
 */
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Vector;

import property.Messages;
import sim.ImgDeviceBean;
import sim.SimulationLog;
import sim.bean.BufferedData;

public class QueueReader implements Runnable {
	private BufferedData bufferedData = null;
	private static String routerServerName=""; //$NON-NLS-1$
	private Thread thread;
	private Socket requestSocket;
	private ObjectOutputStream out;
	private String machineName;
	private String name;
	// start the Thread
	public QueueReader(String name)
	{
		this.name = name;
		machineName = Messages.getString("machineName"); //$NON-NLS-1$
		thread = new Thread(this);
		thread.start();
	}
	// call the execute method in every 5 seconds
	public void run()
	{
		System.out.println("service Thread Started.............\n"); //$NON-NLS-1$
		while(true){
			try {
				executeRequest();
				Thread.sleep(5000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NullPointerException e) {
				// TODO: handle exception
			}
			
		}
	}
	// get the object and process it
	private void executeRequest(){
		System.out.println(name + " HashMap "+RequestQueue.hashMap);
		if(((Vector)RequestQueue.hashMap.get(name)).size()>0)
		{
			//retrieve the first object
			bufferedData = (BufferedData)((Vector)RequestQueue.hashMap.get(name)).get(0);
			//transfer the bufferedtransfer object to process
			Vector vector = bufferedData.getMobileHost();
			for(int i=0;i<vector.size();i++){
				try {
					requestSocket = new Socket(machineName, ((ImgDeviceBean)vector.get(i)).getPort());
					out=new ObjectOutputStream(requestSocket.getOutputStream());
					bufferedData.setDestinationHost(((ImgDeviceBean)vector.get(i)).getName());
					bufferedData.setNetwork(name);
					SimulationLog.write(bufferedData.getFileName() + " is transferred to " +bufferedData.getDestinationHost() + "from " + name);
					out.writeObject(bufferedData);
					System.out.println("Object Transfered."); //$NON-NLS-1$
				} catch (NumberFormatException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnknownHostException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			// remove the corresponding object from the vector
			((Vector)RequestQueue.hashMap.get(name)).remove(0);
		}
	}
}