package wifi;

/*
 * This is main class for WiFi 
 * This class receives all the files from the all source
 * and store into the queue
 * This WifiReceiveClass object is created for all created hosts
 */

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;

import sim.SimulationLog;
import sim.bean.BufferedData;

public class WiFiReceiver implements Runnable {
	private String receivePort = "";
	private BufferedData bufferedData = null;
	private Thread thread;
	
	private final int ALLOWED_QUEUE_SIZE = 200;
	private ServerSocket serverSocket = null;
	private Socket clientSocket = null;
	private ObjectInputStream in = null;
	private ObjectOutputStream out;	
	private int port;
	private String name;
	
	public WiFiReceiver(int port,String name)
	{
		this.port = port;
		this.name = name;
		 new QueueReader(name);
		 try {
//			 serverSocket = new ServerSocket(Integer.parseInt(receivePort));
			 serverSocket = new ServerSocket(port);
		 } catch (NumberFormatException e) {
			 // TODO Auto-generated catch block
			 e.printStackTrace();
		 } catch (IOException e) {
			 // TODO Auto-generated catch block
			 e.printStackTrace();
		 }
//		 System.out.println("Listening");
		 thread=new Thread(this);
		 thread.start();
	}
	public void run()
	{
		System.out.println("the port '" + port + "' of Wifi is running");
		try {
			while(true)
			{
				clientSocket = serverSocket.accept();// create the connection with source
				System.out.println("connection is created");
				in=new ObjectInputStream(clientSocket.getInputStream());//input object to receive the object
				
				System.out.println("In object is created");
				bufferedData = (BufferedData) in.readObject(); //get the object from the source
				SimulationLog.write(bufferedData.getFileName()+"is received in wifi of " + name );
				System.out.println("Ack transferred");
				SimulationLog.write(bufferedData.getFileName()+"is added in queue of " + name );
				((Vector)RequestQueue.hashMap.get(name)).add(bufferedData);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public static void main(String[] args)
	{
//		new WiFiReceiver();
	}
}
